<template>
  <div>
    <v-container fluid class="pa-0 ma-0">
      <v-progress-circular v-if="isLoading" indeterminate color="purple" />
      <v-row
        class="ma-0 px-3 roboto"
        v-if="$store.getters['subscription/getValidateSubscription'] == false"
      >
        <v-alert
          v-show="!isLoading"
          color="tway-violet"
          dismissible
          outlined
          icon="mdi-information-outline"
          class="rounded-xl"
          close-icon="mdi-close-circle-outline"
        >
          <span style="line-height: 20px; font-weight: bold"
            >Por ser suscriptor Tway aprovecha el 50% de descuento para la
            Conferencia de Transformación Digital más importante del año.
            Promoción por tiempo limitado. Ingresa
            <a
              class="tway-violet--text text-decoration-underline"
              @click="
                () => {
                  $router.push({ path: 'trends/6091af9bfa1eb340b074175d' });
                }
              "
              >aquí</a
            >.</span
          >
        </v-alert>
      </v-row>
      <v-row v-show="!isLoading" class="ma-0 pa-0" align="stretch">
        <v-col class="ma-0" :class="desktop ? 'py-15' : ''" v-if="!complete">
          <v-row width="100%" justify="center" align="center" class="ma-0 pa-0">
          </v-row>
          <v-row width="100%" justify="center" align="center" class="ma-0 pa-0">
          </v-row>
          <v-row
            width="100%"
            justify="center"
            align="center"
            class="mx-0 my-13 pa-0"
          >
          </v-row>
        </v-col>
        <v-col
          class="ma-0"
          cols="12"
          xs="12"
          sm="12"
          md="3"
          lg="3"
          xl="3"
          v-if="complete"
        >
          <v-card class="pa-5" height="100%">
            <v-row
              width="100%"
              justify="center"
              align="center"
              class="mb-6 ma-0 pa-0"
            >
              <span class="title-idx-text center-text"
                >Tu Índice de {{ percentage.name }}</span
              >
            </v-row>
            <v-row
              width="100%"
              justify="center"
              align="center"
              class="mb-6 ma-0 pa-0"
            >
              <v-tooltip right>
                <template v-slot:activator="{ on, attrs }">
                  <v-progress-circular
                    :rotate="-90"
                    :size="180"
                    :width="22"
                    v-bind="attrs"
                    v-on="on"
                    :value="percentage.value"
                    color="#16C62E"
                  >
                    <span class="roboto pertentage-text"
                      >{{ percentage.value }}%</span
                    >
                  </v-progress-circular>
                </template>
                <div style="max-width: 400px" class="pt-3">
                  <strong>Transformación en Tway</strong>
                  <br />
                  <p>
                    Proceso adaptativo estratégico para que las empresas ajusten
                    su mentalidad y modelo de negocio, integrando facilitadores
                    tecnológicos y capacidades digitales a sus operadores, con
                    el fin de crear valor en la Economía Digital y ser
                    competitivos.
                  </p>
                </div>
              </v-tooltip>
            </v-row>
            <v-row
              width="100%"
              justify="center"
              align="center"
              class="mb-6 ma-0 pa-0"
            >
              <span class="title-idx-subtitle" v-if="percentage.index">
                <span v-if="dti.score * 10 <= 40">Nivel Básico</span>
                <span v-if="dti.score * 10 > 40 && dti.score * 10 <= 60"
                  >Nivel Inicial</span
                >
                <span v-if="dti.score * 10 > 60 && dti.score * 10 <= 80"
                  >Nivel Estratégico</span
                >
                <span v-if="dti.score * 10 > 80">Nivel competitivo</span>
              </span>
            </v-row>
            <v-row
              width="100%"
              justify="start"
              align="center"
              class="mb-1 ma-0 pa-0"
            >
              <span class="roboto body-idx-text mb-4">
                <span
                  style="white-space: pre-wrap; word-wrap: break-word"
                  v-if="dti.score * 10 <= 40"
                  >{{ levels[0] }}</span
                >
                <span
                  style="white-space: pre-wrap; word-wrap: break-word"
                  v-if="dti.score * 10 > 40 && dti.score * 10 <= 60"
                  >{{ levels[1] }}</span
                >
                <span
                  style="white-space: pre-wrap; word-wrap: break-word"
                  v-if="dti.score * 10 > 60 && dti.score * 10 <= 80"
                  >{{ levels[2] }}</span
                >
                <span
                  style="white-space: pre-wrap; word-wrap: break-word"
                  v-if="dti.score * 10 > 80"
                  >{{ levels[3] }}</span
                >
              </span>
            </v-row>
          </v-card>
        </v-col>
        <v-col
          class="ma-0"
          cols="12"
          xs="12"
          sm="12"
          md="9"
          lg="9"
          xl="9"
          v-if="complete"
        >
          <dashboard-client
            v-if="sector.type === 'CLIENT'"
            @finishloading="finishloading"
          />
          <dashboard-specialist
            v-if="sector.type === 'SPECIALIST'"
            @finishloading="finishloading"
          />
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>

<style scoped lang="scss">
.no-dashboard-text {
  font-size: 16px;
  line-height: 24px;
  font-weight: 400;
  text-align: center;
}

.small-btn-text-1 {
  font-size: 10px;
  color: #7319d5;
}

.small-btn-text-2 {
  font-size: 10px;
  color: #999999;
}

.center-text {
  text-align: center !important;
}

.title-idx-text {
  font-size: 23px;
  width: 100%;
  .element {
    text-transform: lowercase;
  }
  line-height: 30px;
  font-weight: 400;
  text-align: start;
}

.title-idx-small {
  font-size: 14px;
  .element {
    text-transform: lowercase;
  }
  line-height: 30px;
  font-weight: 400;
  text-align: start;
}

.place-icon {
  display: flex;
  flex-direction: column;
  align-items: center;
  span {
    margin-bottom: -37px;
    font-size: 26px;
    font-weight: bold;
    color: #7319d5;
  }
}

.place-icon-first {
  display: flex;
  flex-direction: column;
  align-items: center;
  span {
    margin-bottom: -50px;
    font-size: 35px;
    font-weight: bold;
    color: #16c62e;
  }
}

.title-idx-subtitle {
  font-size: 25px;
  line-height: 30px;
  font-weight: 700;
  text-align: start;
  color: #7319d5;
}

.item-title {
  font-size: 12px;
  line-height: 14px;
  width: 100%;
  font-weight: 400;
  text-align: start;
  cursor: pointer;
}

.item-title:hover,
.item-title:focus {
  color: rgba(#000, 0.6);
}

.item-score {
  font-size: 30px;
  width: 100%;
  line-height: 14px;
  font-weight: 400;
  color: #333333;
  text-align: start;
}

.item-score-danger {
  font-size: 30px;
  width: 100%;
  color: #b71c1c;
  line-height: 14px;
  font-weight: 400;
  text-align: start;
}

.center-card {
  display: flex;
  justify-content: center;
  align-items: center;
  flex-direction: column;
}

.body-idx-text {
  font-size: 16px;
  line-height: 20px;
  font-weight: 400;
  text-align: start;
  color: rgba(#000, 0.8);
}

.pertentage-text {
  color: #4a148c;
  font-size: 50px;
  line-height: 82.03px;
  text-align: center;
  font-weight: 700;
}

.pertentage-text-danger {
  color: #b71c1c;
  font-size: 50px;
  line-height: 82.03px;
  text-align: center;
  font-weight: 700;
}

.full-height {
  height: 100%;
}

.border-bottom {
  border-bottom: 1px solid #dedede;
}

.worse-title {
  color: #7319d5;
  text-transform: lowercase;
}

.worse-text {
  font-size: 16px;
}
</style>

<script>
import dtService from "@/services/dtService";
import currentUserService from "@/services/currentUserService";
import companyService from "@/services/companyService";
import DashboardClient from "@/components/dashboard/DashboardClient";
import DashboardSpecialist from "@/components/dashboard/DashboardSpecialist";
import { mapActions, mapGetters } from "vuex";

export default {
  components: {
    "dashboard-client": DashboardClient,
    "dashboard-specialist": DashboardSpecialist,
  },

  data: () => ({
    sector: {},
    flagRanking: 1,
    percentage: {
      value: 0,
      name: "Madurez en Transformación Digital",
      index: true,
    },
    rankingGlobal: [],
    rankingGlobalNumber: 0,
    rankingSectorNumber: 0,
    rankingSector: [],
    levels: [
      "La empresa enfrenta el futuro con mentalidad mayoritariamente analógica, sin plan digital. Suma innovaciones aisladas. Opera con sistemas rígidos y poco eficientes para adaptarse a los intereses de los clientes y del mercado. Aspira a incorporar la Transformación Digital, pero las decisiones son tardías y lentas. Falta un liderazgo que impulse el proceso de transformación. Aparecen resistencias. La organización persiste en hacer las cosas como hasta ahora, sin integrar competencias digitales. La organización está enfocada en una rentabilidad de corto plazo. Su competitividad futura es baja.",
      "La empresa integra innovaciones en procesos específicos para bajar costos y aumentar margen. Resuelve problemas actuales con tecnologías, más que cambiar la forma de hacer las cosas. Pone en marca acciones digitales, sin claridad sobre el valor que tendrán en el negocio futuro.\n\nPersisten resistencias y una cultura de trabajo en silos, sin lograr agilizar la transformación digital, ni impregnar a toda la organización. Necesita un propósito alineado a un proyecto digital estructurado, y liderazgos comprometidos con una ruta hacia la Transformación integral. \n\nIncorpora competencias digitales para adoptar nuevos modelos de negocio. Pone en marcha algunos servicios con foco en los clientes y su comportamiento, priorizando acciones de marketing.",
      "La empresa alinea su propósito a la Transformación Digital como estrategia de negocio. \n\nProyecta una cultura orientada al cliente y data driven, para tomar decisiones, escalar el negocio, aumentar la velocidad de salida al mercado y adaptar la propuesta de valor a escenarios dinámicos. \n\nEstablece liderazgos comprometidos con los cambios. Incorpora modelos de aprendizaje continuo. Impulsa la colaboración entre equipos autónomos y multidisciplinarios. Establece alianzas con ecosistemas externos para lograr eficiencias y mejorar la rentabilidad futura.\n\nLa data, innovación y las tecnologías son activos estratégicos transversales para volverse más ágil, automatizar procesos y escalar. Mapea la experiencia de los clientes de principio a fin, monitorea su satisfacción, interactúa con ellos en espacios digitales y gestiona activamente fallas operacionales.",
      "La estrategia, proyecto y gestión de Transformación Digital es central y transversal. Completamente integrada al negocio, busca crear ventajas competitivas a largo plazo en contextos dinámicos. La tecnología es su aliado en la nube. \n\nPromueve una nueva mentalidad a través de un propósito vinculante, potenciando una inteligencia colectiva. Nace una cultura corporativa flexible, auto motivada y abierta a la innovación. Surgen liderazgos que permiten orquestar los cambios de forma ágil, distribuyendo las decisiones críticas. \n\nCuenta con un ecosistema que incentiva el aprendizaje continuo, incorporando los errores o fallos de forma constructiva, prototipando para escalar rápido. \n\nLos clientes son entendidos como una red, los conecta de manera multicanal y sin fricciones, motivándolos a colaborar en crear su oferta de valor. La data es un activo para conocerlos y anticiparse a la futura interacción que tendrán con sus productos y servicios; el fin, entregar una experiencia exitosa.",
    ],
    dimensions: [
      {
        value: 0,
        name: "MODELO DE NEGOCIO",
        image: "bars.svg",
        id: "",
        description:
          "Cuestionar los actuales diferenciadores de negocio y proyectar a la competencia como socio colaborativo para fortalecer la propuesta de valor futura. Compartir data financiera y operacional al interior de la organización.Mapear el viaje del cliente y su soporte, la cadena de suministro, canales de distribución y posibles alianzas para impulsar oportunidades, bajar costos y actuar ágil al incoprorar tecnologías, data e innovaciones.",
      },
      {
        value: 0,
        name: "FACILITADORES",
        image: "console.svg",
        id: "",
        description:
          "Lorem ipsum dolor sit amet, consectetur adipisicing elit. Magnam eligendi hic in accusamus quasi, consectetur voluptate tempore esse neque a dicta quaerat veniam, consequuntur sequi, vel aspernatur sed nemo magni!",
      },
      {
        value: 0,
        name: "MENTALIDAD",
        image: "users.svg",
        id: "",
        description:
          "Lorem ipsum dolor sit amet, consectetur adipisicing elit. Magnam eligendi hic in accusamus quasi, consectetur voluptate tempore esse neque a dicta quaerat veniam, consequuntur sequi, vel aspernatur sed nemo magni!",
      },
      {
        value: 0,
        name: "ORQUESTACIÓN",
        image: "barsup.svg",
        id: "",
        description:
          "Lorem ipsum dolor sit amet, consectetur adipisicing elit. Magnam eligendi hic in accusamus quasi, consectetur voluptate tempore esse neque a dicta quaerat veniam, consequuntur sequi, vel aspernatur sed nemo magni!",
      },
    ],
    isLoading: true,
    complete: false,
    dti: {
      score: 0,
      dimensions: [],
    },
    selectedDimension: null,
    series: [
      {
        data: [0, 0, 0, 0],
      },
    ],
    chartOptions: {
      toolbar: {
        show: false,
      },
      xaxis: {
        categories: [
          ["ORQUESTACIÓN"],
          ["MODELO", "DE", "NEGOCIO"],
          "FACILITADORES",
          ["MENTALIDAD"],
        ],
      },
      stroke: {
        show: true,
        width: 2,
        colors: ["#15c62e"],
        dashArray: 0,
      },
      markers: {
        size: 0,
        hover: {
          size: 10,
        },
      },
      fill: {
        opacity: 0.15,
        colors: ["#7D00FF"],
      },
      plotOptions: {
        radar: {
          size: 80,
          offsetX: 0,
          offsetY: 0,
          polygons: {
            strokeColors: "#e9dbf9",
            strokeWidth: 1,
            strokeDash: 4,
            connectorColors: "#DCC5F4",
            fill: {
              colors: undefined,
            },
          },
        },
      },
      labels: {
        show: true,
        style: {
          colors: ["#000000"],
          fontSize: "13px",
          fontFamily: "Roboto Condensed",
        },
      },
    },
  }),

  async created() {
    try {
      this.isLoading = true;
      const userData = await currentUserService.currentUserData();
      this.user = userData;

      const questions = await dtService.getSurveyComplete("a123", this.user.id);
      this.SET_PERCENTAGE(
        Math.floor((questions.answered / questions.total) * 100)
      );

      if (this.getPercentage != 100) {
        this.complete = false;
        this.isLoading = false;
        this.$router.push({ name: "dti-form" });
      } else {
        this.complete = true;
        this.getDti(this.user.id, questions.surveyId);
      }
    } catch (error) {
      this.$log.error(error);
    }
  },
  methods: {
    ...mapActions("UserStore", ["SET_PERCENTAGE"]),
    finishloading() {
      this.isLoading = false;
    },
    toFixed(num, fixed) {
      var re = new RegExp("^-?\\d+(?:\\.\\d{0," + (fixed || -1) + "})?");
      return num.toString().match(re)[0];
    },
    changePercentage(index) {
      this.percentage = {
        name: this.dimensions[index].name,
        value: this.dimensions[index].value,
        index: false,
      };
    },
    async getDti(userId, surveyId) {
      try {
        const dti = await dtService.getDti(userId, surveyId);
        if (!dti.dimensions) {
          this.$router.push({ name: "my-plan" });
        }

        this.dti = dti;
        this.selectedDimension = dti.dimensions[0];
        this.percentage.value = (this.dti.score * 10).toFixed(0);

        try {
          this.sector = await companyService.getCompanyProfile();
        } catch (error) {
          this.$log.error("Unexpected error: %s", error);
        }
      } catch (err) {
        this.$log.error("Consola dashboard: %s", err);

        if (err.response.status === 409) {
          this.$router.push({ name: "my-plan" });
        }
        this.$log.error("Unexpected error: ", err);
      }
    },
  },
  computed: {
    ...mapGetters("UserStore", ["getPercentage"]),
    mobile() {
      return this.$vuetify.breakpoint.sm || this.$vuetify.breakpoint.xs;
    },
    desktop() {
      return (
        this.$vuetify.breakpoint.md ||
        this.$vuetify.breakpoint.lg ||
        this.$vuetify.breakpoint.xl
      );
    },
  },
};
</script>
